<?php
/**
 * OTT Vlogger functions and definitions
 * @package OTT Vlogger
 */

if ( ! function_exists( 'ott_vlogger_after_theme_support' ) ) :

	function ott_vlogger_after_theme_support() {
		
		add_theme_support( 'automatic-feed-links' );

		add_theme_support('woocommerce');
        add_theme_support('wc-product-gallery-zoom');
        add_theme_support('wc-product-gallery-lightbox');
        add_theme_support('wc-product-gallery-slider');
        add_theme_support('woocommerce', array(
            'gallery_thumbnail_image_width' => 300,
        ));

		add_theme_support(
			'custom-background',
			array(
				'default-color' => 'ffffff',
			)
		);

		$GLOBALS['content_width'] = apply_filters( 'ott_vlogger_content_width', 1140 );
		
		add_theme_support( 'post-thumbnails' );

		add_theme_support(
			'custom-logo',
			array(
				'height'      => 270,
				'width'       => 90,
				'flex-height' => true,
				'flex-width'  => true,
			)
		);
		
		add_theme_support( 'title-tag' );

		add_theme_support(
			'html5',
			array(
				'search-form',
				'comment-form',
				'comment-list',
				'gallery',
				'caption',
				'script',
				'style',
			)
		);

		add_theme_support( 'post-formats', array(
			'video',  
			'audio',  
			'gallery',
			'quote',  
			'image',  
			'link',   
			'status', 
			'aside',  
			'chat',   
		) );
		
		add_theme_support( 'align-wide' );
		add_theme_support( 'responsive-embeds' );
		add_theme_support( 'wp-block-styles' );

		require get_template_directory() . '/inc/metabox.php';
		require get_template_directory() . '/inc/homepage-setup/homepage-setup-settings.php';

		if (! defined( 'OTT_VLOGGER_DOCS_PRO' ) ){
		define('OTT_VLOGGER_DOCS_PRO',__('https://layout.omegathemes.com/steps/pro-ott-vlogger/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_BUY_NOW' ) ){
		define('OTT_VLOGGER_BUY_NOW',__('https://www.omegathemes.com/products/ott-wordpress-theme/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_SUPPORT_FREE' ) ){
		define('OTT_VLOGGER_SUPPORT_FREE',__('https://wordpress.org/support/theme/ott-vlogger/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_REVIEW_FREE' ) ){
		define('OTT_VLOGGER_REVIEW_FREE',__('https://wordpress.org/support/theme/ott-vlogger/reviews/#new-post/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_DEMO_PRO' ) ){
		define('OTT_VLOGGER_DEMO_PRO',__('https://layout.omegathemes.com/ott-vlogger/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_LITE_DOCS_PRO' ) ){
		define('OTT_VLOGGER_LITE_DOCS_PRO',__('https://layout.omegathemes.com/steps/free-ott-vlogger/','ott-vlogger'));
		}
		if (! defined( 'OTT_VLOGGER_BUNDLE_BUTTON' ) ){
			define('OTT_VLOGGER_BUNDLE_BUTTON',__('https://www.omegathemes.com/products/wp-theme-bundle','ott-vlogger'));
		}

	}

endif;

add_action( 'after_setup_theme', 'ott_vlogger_after_theme_support' );

/**
 * Register and Enqueue Styles.
 */
function ott_vlogger_register_styles() {

	wp_enqueue_style( 'dashicons' );

    $ott_vlogger_theme_version = wp_get_theme()->get( 'Version' );
	$ott_vlogger_fonts_url = ott_vlogger_fonts_url();
    if( $ott_vlogger_fonts_url ){
    	require_once get_theme_file_path( 'lib/custom/css/wptt-webfont-loader.php' );
        wp_enqueue_style(
			'ott-vlogger-google-fonts',
			ott_vlogger_wptt_get_webfont_url( $ott_vlogger_fonts_url ),
			array(),
			$ott_vlogger_theme_version
		);
    }

    wp_enqueue_style( 'swiper', get_template_directory_uri() . '/lib/swiper/css/swiper-bundle.min.css');
	wp_enqueue_style( 'ott-vlogger-style', get_stylesheet_uri(), array(), $ott_vlogger_theme_version );

	wp_enqueue_style( 'ott-vlogger-style', get_stylesheet_uri() );
	require get_parent_theme_file_path( '/custom_css.php' );
	wp_add_inline_style( 'ott-vlogger-style',$ott_vlogger_custom_css );

	$ott_vlogger_css = '';

	if ( get_header_image() ) :

		$ott_vlogger_css .=  '
			.header-main{
				background-image: url('.esc_url(get_header_image()).');
				-webkit-background-size: cover !important;
				-moz-background-size: cover !important;
				-o-background-size: cover !important;
				background-size: cover !important;
			}';

	endif;

	wp_add_inline_style( 'ott-vlogger-style', $ott_vlogger_css );

	if ( is_singular() && comments_open() && get_option( 'thread_comments' ) ) {
		wp_enqueue_script( 'comment-reply' );
	}	

	wp_enqueue_script( 'imagesloaded' );
    wp_enqueue_script( 'masonry' );
	wp_enqueue_script( 'swiper', get_template_directory_uri() . '/lib/swiper/js/swiper-bundle.min.js', array('jquery'), '', 1);
	wp_enqueue_script( 'ott-vlogger-custom', get_template_directory_uri() . '/lib/custom/js/theme-custom-script.js', array('jquery'), '', 1);

    // Global Query
    if( is_front_page() ){

    	$ott_vlogger_posts_per_page = absint( get_option('posts_per_page') );
        $ott_vlogger_c_paged = ( get_query_var( 'page' ) ) ? absint( get_query_var( 'page' ) ) : 1;
        $ott_vlogger_posts_args = array(
            'posts_per_page'        => $ott_vlogger_posts_per_page,
            'paged'                 => $ott_vlogger_c_paged,
        );
        $ott_vlogger_posts_qry = new WP_Query( $ott_vlogger_posts_args );
        $max = $ott_vlogger_posts_qry->max_num_pages;

    }else{
        global $wp_query;
        $max = $wp_query->max_num_pages;
        $ott_vlogger_c_paged = ( get_query_var( 'paged' ) > 1 ) ? get_query_var( 'paged' ) : 1;
    }

    $ott_vlogger_default = ott_vlogger_get_default_theme_options();
    $ott_vlogger_pagination_layout = get_theme_mod( 'ott_vlogger_pagination_layout',$ott_vlogger_default['ott_vlogger_pagination_layout'] );
}

add_action( 'wp_enqueue_scripts', 'ott_vlogger_register_styles',200 );

function ott_vlogger_admin_enqueue_scripts_callback() {
    if ( ! did_action( 'wp_enqueue_media' ) ) {
    wp_enqueue_media();
    }
    wp_enqueue_script('ott-vlogger-uploaderjs', get_stylesheet_directory_uri() . '/lib/custom/js/uploader.js', array(), "1.0", true);
}
add_action( 'admin_enqueue_scripts', 'ott_vlogger_admin_enqueue_scripts_callback' );

/**
 * Register navigation menus uses wp_nav_menu in five places.
 */
function ott_vlogger_menus() {

	$ott_vlogger_locations = array(
		'ott-vlogger-primary-menu'  => esc_html__( 'Primary Menu', 'ott-vlogger' ),
	);

	register_nav_menus( $ott_vlogger_locations );
}

add_action( 'init', 'ott_vlogger_menus' );

add_filter('loop_shop_columns', 'ott_vlogger_loop_columns');
if (!function_exists('ott_vlogger_loop_columns')) {
	function ott_vlogger_loop_columns() {
		$ott_vlogger_columns = get_theme_mod( 'ott_vlogger_per_columns', 3 );
		return $ott_vlogger_columns;
	}
}

add_filter( 'loop_shop_per_page', 'ott_vlogger_per_page', 20 );
function ott_vlogger_per_page( $ott_vlogger_cols ) {
  	$ott_vlogger_cols = get_theme_mod( 'ott_vlogger_product_per_page', 9 );
	return $ott_vlogger_cols;
}

add_filter( 'woocommerce_output_related_products_args', 'ott_vlogger_products_args' );

function ott_vlogger_products_args( $ott_vlogger_args ) {

    $ott_vlogger_args['posts_per_page'] = get_theme_mod( 'ott_vlogger_custom_related_products_number', 6 );

    $ott_vlogger_args['columns'] = get_theme_mod( 'ott_vlogger_custom_related_products_number_per_row', 3 );

    return $ott_vlogger_args;
}

require get_template_directory() . '/inc/custom-header.php';
require get_template_directory() . '/classes/class-svg-icons.php';
require get_template_directory() . '/classes/class-walker-menu.php';
require get_template_directory() . '/inc/customizer/customizer.php';
require get_template_directory() . '/inc/custom-functions.php';
require get_template_directory() . '/inc/template-tags.php';
require get_template_directory() . '/classes/body-classes.php';
require get_template_directory() . '/inc/widgets/widgets.php';
require get_template_directory() . '/inc/pagination.php';
require get_template_directory() . '/lib/breadcrumbs/breadcrumbs.php';
require get_template_directory() . '/lib/custom/css/dynamic-style.php';


function ott_vlogger_remove_customize_register() {
    global $wp_customize;

    $wp_customize->remove_setting( 'display_header_text' );
    $wp_customize->remove_control( 'display_header_text' );

}

add_action( 'customize_register', 'ott_vlogger_remove_customize_register', 11 );

// Apply styles based on customizer settings

function ott_vlogger_radio_sanitize(  $ott_vlogger_input, $ott_vlogger_setting  ) {
	$ott_vlogger_input = sanitize_key( $ott_vlogger_input );
	$ott_vlogger_choices = $ott_vlogger_setting->manager->get_control( $ott_vlogger_setting->id )->choices;
	return ( array_key_exists( $ott_vlogger_input, $ott_vlogger_choices ) ? $ott_vlogger_input : $ott_vlogger_setting->default );
}
require get_template_directory() . '/inc/general.php';

function ott_vlogger_sticky_sidebar_enabled() {
    $ott_vlogger_sticky_sidebar = get_theme_mod('ott_vlogger_sticky_sidebar', true);
    
    if ($ott_vlogger_sticky_sidebar == false) {
        $ott_vlogger_custom_css = ".widget-area-wrapper { position: relative !important; }";
        wp_add_inline_style('ott-vlogger-style', $ott_vlogger_custom_css);
    }
}
add_action('wp_enqueue_scripts', 'ott_vlogger_sticky_sidebar_enabled');

add_filter( 'woocommerce_enable_setup_wizard', '__return_false' );

// NOTICE FUNCTION

function ott_vlogger_admin_notice() { 
    global $pagenow;
    $theme_args = wp_get_theme();
    $meta = get_option( 'ott_vlogger_admin_notice' );
    $name = $theme_args->get( 'Name' );
    $current_screen = get_current_screen();

    if ( ! $meta ) {
        if ( is_network_admin() ) {
            return;
        }

        if ( ! current_user_can( 'manage_options' ) ) {
            return;
        }

        if ( $current_screen->base != 'appearance_page_ottvlogger-wizard' ) {
            ?>
            <div class="notice notice-success notice-content">
                <h2><?php esc_html_e('Welcome! Thank you for choosing OTT Vlogger. Let’s Set Up Your Website!', 'ott-vlogger') ?> </h2>
                <p><?php esc_html_e('Before you dive into customization, let’s go through a quick setup process to ensure everything runs smoothly. Click below to start setting up your website in minutes!', 'ott-vlogger') ?> </p>
                <div class="info-link">
                    <a href="<?php echo esc_url( admin_url( 'themes.php?page=ottvlogger-wizard' ) ); ?>"><?php esc_html_e('Get Started with OTT Vlogger', 'ott-vlogger'); ?></a>
                </div>
                <p class="dismiss-link"><strong><a href="?ott_vlogger_admin_notice=1"><?php esc_html_e( 'Dismiss', 'ott-vlogger' ); ?></a></strong></p>
            </div>
            <?php
        }
    }
}
add_action( 'admin_notices', 'ott_vlogger_admin_notice' );

if ( ! function_exists( 'ott_vlogger_update_admin_notice' ) ) :
/**
 * Updating admin notice on dismiss
 */
function ott_vlogger_update_admin_notice() {
    if ( isset( $_GET['ott_vlogger_admin_notice'] ) && $_GET['ott_vlogger_admin_notice'] == '1' ) {
        update_option( 'ott_vlogger_admin_notice', true );
    }
}
endif;
add_action( 'admin_init', 'ott_vlogger_update_admin_notice' );

// After Switch theme function
add_action( 'after_switch_theme', 'ott_vlogger_getstart_setup_options' );
function ott_vlogger_getstart_setup_options() {
    update_option( 'ott_vlogger_admin_notice', false );
}